\ Blink an LED on P4 - exit on any key
: BLINKY		BEGIN 4 MASK OUTSET #100 ms 4 MASK OUTCLR #100 ms KEY? AND UNTIL ;

: NFA>CFA  BEGIN C@++ $7F > UNTIL ;

: WORDS	  
	names W@ 
	BEGIN 
	CR DUP .W 3A EMIT BL EMIT 
	DUP NFA>CFA 1- DUP 3 ADO I C@ .B BL EMIT LOOP 
	3 + 
	SWAP .STR BL EMIT 
	DUP C@ 0= 
	UNTIL 
	DROP CR 
	;

: AWORDS
	CR ." Tachyon Forth " 	  
	0 names W@ 
	BEGIN 
	OVER 7 AND 0= IF CR THEN 
	DUP .STR BL EMIT 
	NFA>CFA 2+ 
	SWAP 1+ SWAP 
	DUP C@ 0= 
	UNTIL 
	2DROP CR 
	;



\ **************************** VGA FUNCTIONS ********************

: CLS		pixels W@ $6000 ERASE ;

: COLORS	colors W@ W! colors W@ DUP 2+ #382 CMOVE ;

$FF04 COLORS

: PLOT ( x y -- ) 
	6 SHL OVER 3 SHR +  
	SWAP 7 AND MASK SWAP pixels W@ + SET 
	;


: HLINE  ( x y length -- ) 
	ROT SWAP ADO I OVER PLOT LOOP DROP 
	;
	
: VLINE  ( x y length -- ) 
	ADO DUP I PLOT LOOP DROP 
	;

: ITEM	2* 2* @REG ;

: GRAB  ( items -- ) 0 DO 	I ITEM ! LOOP ;

: RECT ( x1 y1 xlen ylen -- ) 
	4 GRAB 
	3 ITEM @ 2 ITEM @ 1 ITEM @ HLINE 
	3 ITEM @ 1 ITEM @ + 2 ITEM @ 0 ITEM @ VLINE 
	3 ITEM @ 2 ITEM @ 0 ITEM @ VLINE 
	3 ITEM @ 2 ITEM @ 0 ITEM @ + 1 ITEM @ HLINE 
	;

: BOXES
	CLS 
	#334 0 DO I I 100 50 RECT 4 +LOOP 
	\ $C0 $C0 $30 FOR 2DUP $80 $40 RECT SWAP 4 + SWAP 4 - NEXT 2DROP 
;


